
// Setup the client to read sensor data from the server
#include <ESP8266WiFi.h>

// Initialize network parameters

const char* ssid = "my-lan-name"; // enter the LAN SSID between the double quotes
const char* password = "my-lan-password"; // enter the password
const char* host = "192.168.1.999"; // enter the IP address of the recently created WiFi Weather Station - this is your host
String url, line = "";
int RXHr, RXMin, beenOnFlag = 0; // 1 = night, 0 = day
int relayPin = LED_BUILTIN;
// int relayPin = 4;
// Set up the client object
WiFiClient client;

void setup() {
  // Configure the sensor pin 
  pinMode(relayPin, OUTPUT);
  digitalWrite(relayPin,HIGH);
  // Connect to the server
  WiFi.hostname("auto_lamp1"); // name of this devise on your LAN
  WiFi.begin(ssid,password);
  Serial.begin(9600);
  while(WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    delay(500);
  }
  Serial.println();
  Serial.print("IP Address (AP): "); 
  Serial.println(WiFi.localIP());
}

void loop() {
  // put your main code here, to run repeatedly:

  if(client.connect(host,80)) {
//////////////////////////////////////////////////////////////////////////////////////////////    

    url = "/localTime";
    client.print(String("GET ") + url + " HTTP/1.1\r\n" + "Host: " + host +  "\r\n" + 
           "Connection: Keep-Alive\r\n\r\n"  ); // minimum set of required URL headers
    delay(10);

    while(client.available()){
      line = client.readStringUntil('\r');
      if (line.indexOf("-20") > 0) {// extract elements from time/date string
        String RXdayofWeek = line.substring(1,line.indexOf(","));
        String RXdate      = line.substring(line.indexOf("-") -2, line.indexOf("-") +9);                                         
        String RXtime      = line.substring(line.indexOf(":") -2, line.indexOf(":") +6);               
        RXHr               = RXtime.substring(0,2).toInt();
        RXMin              = (RXtime.substring(RXtime.indexOf(":") +1, RXtime.indexOf(":") +3)).toInt();

        if ((beenOnFlag == 0) and (RXHr > 22)) {// turn light off at 11pm 
          digitalWrite(relayPin,HIGH);
          beenOnFlag = 1; 
        }
        Serial.println(RXdayofWeek);        
        Serial.println(RXdate);        
        Serial.println(RXtime);        
        Serial.println(RXHr);        
        Serial.println(RXMin);        
      }    
    }
  }
    client.stop();
  delay(14990);  
  
// capture next parameter  //////////////////////////////////////////////////

  if(client.connect(host,80)) {
    url = "/dayNight";
    client.print(String("GET ") + url + " HTTP/1.1\r\n" + "Host: " + host +  "\r\n" + 
           "Connection: Keep-Alive\r\n\r\n" ); // minimum set of required URL headers
    delay(10);

    while(client.available()){
      line = client.readStringUntil('\r');
      if (line.indexOf("Day") > 0) { // what key words to search for - from the host
      Serial.println("Light");
      digitalWrite(relayPin,HIGH);
      beenOnFlag = 0;
      }
      else if ((line.indexOf("Night") > 0) and (beenOnFlag == 0))  {
      Serial.println("Dark");
      digitalWrite(relayPin,LOW);
     
      }
    }
      client.stop();
////////////////////////////////////////      
delay(14990);
  } 
}
